



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android MediaPlayer架构 -- 前言小知识点（一）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android MediaPlayer架构 -- 前言小知识点（一）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-01 09:04:37 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　在Android中可以使用MediaPlayer+SurfaceView来实现一个简单的多媒体播放器。</p>
<h2>一 &nbsp;构造函数</h2>
<p>　　java MediaPlayer class 的源码位置：frameworks\base\media\java\android\media\MediaPlayer.java</p>
<p>　　首先看一下其构造函数：</p>
<div>
<pre class="prettyprint linenums">     public MediaPlayer() {

         Looper looper;<br />
         if ((looper = Looper.myLooper()) != null) {<br />
             mEventHandler = new EventHandler(this, looper);<br />
         } else if ((looper = Looper.getMainLooper()) != null) {<br />
             mEventHandler = new EventHandler(this, looper);<br />
         } else {<br />
             mEventHandler = null;<br />
         }

         mTimeProvider = new TimeProvider(this);<br />
         mOpenSubtitleSources = new Vector&lt;InputStream&gt;();<br />
         IBinder b = ServiceManager.getService(Context.APP_OPS_SERVICE);<br />
         mAppOps = IAppOpsService.Stub.asInterface(b);

         /* Native setup requires a weak reference to our object.<br />
          * It's easier to create it here than in C++.<br />
          */<br />
         native_setup(new WeakReference&lt;MediaPlayer&gt;(this)); // 在实例化MediaPlayer对象时，会调用一个native_setup方法<br />
     }</pre>
</div>
<p>　　在实例化MediaPlayer对象时，会调用一个native_setup方法：</p>
<div>
<pre class="prettyprint linenums"> private native final void native_setup(Object mediaplayer_this);</pre>
</div>
<p>　　在JNI代码（frameworks\base\media\jni\android_media_MediaPlayer.cpp）中可以找到对应的native函数：</p>
<div>
<pre class="prettyprint linenums"> static void<br />
 android_media_MediaPlayer_native_setup(JNIEnv *env, jobject thiz, jobject weak_this)<br />
 {<br />
     ALOGV("native_setup");<br />
     sp&lt;MediaPlayer&gt; mp = new MediaPlayer(); // 实例化一个native MediaPlayer(frameworks\av\media\libmedia\mediaplayer.cpp)<br />
     if (mp == NULL) {<br />
         jniThrowException(env, "java/lang/RuntimeException", "Out of memory");<br />
         return;<br />
     }

     // create new listener and give it to MediaPlayer<br />
     sp&lt;JNIMediaPlayerListener&gt; listener = new JNIMediaPlayerListener(env, thiz, weak_this);<br />
     mp-&gt;setListener(listener);

     // Stow our new C++ MediaPlayer in an opaque field in the Java object.<br />
     setMediaPlayer(env, thiz, mp);<br />
 }</pre>
</div>
<p>　　在JNI可以看到，sp&lt;MediaPlayer&gt; mp = new MediaPlayer() 这个native MediaPlayer会去和media service进行交互实现真正的播放功能。</p>
<h2>二 &nbsp;设置Listener</h2>
<p>　　在JNI 函数&nbsp;android_media_MediaPlayer_native_setup 中有为MediaPlayer设置listener，目的就是通过callback的方式将player的事件上传至java层，以便用户做出对应的处理</p>
<div>
<pre class="prettyprint linenums">     // create new listener and give it to MediaPlayer<br />
     sp&lt;JNIMediaPlayerListener&gt; listener = new JNIMediaPlayerListener(env, thiz, weak_this);<br />
     mp-&gt;setListener(listener);</pre>
</div>
<p>　　从上面这两行代码可以看到，首先我们实例化一个JNIMediaPlayerListener对象，然后将这个对象传递给了C++ MediaPlayer，在frameworks\av\include\media\mediaplayer.h中定义了listener的接口形式：</p>
<div>
<pre class="prettyprint linenums"> // ref-counted object for callbacks<br />
 class MediaPlayerListener: virtual public RefBase<br />
 {<br />
 public:<br />
     virtual void notify(int msg, int ext1, int ext2, const Parcel *obj) = ;<br />
 };</pre>
</div>
<p>　　在JNI代码中，JNIMediaPlayerListener class 正是一个MediaPlayerListener的子类，实现了notify函数，其定义如下：</p>
<div>
<pre class="prettyprint linenums">// ref-counted object for callbacks<br />
class JNIMediaPlayerListener: public MediaPlayerListener<br />
{<br />
public:<br />
    JNIMediaPlayerListener(JNIEnv* env, jobject thiz, jobject weak_thiz);<br />
    ~JNIMediaPlayerListener();<br />
    virtual void notify(int msg, int ext1, int ext2, const Parcel *obj = NULL);<br />
private:<br />
    JNIMediaPlayerListener();<br />
    jclass      mClass;     // Reference to MediaPlayer class<br />
    jobject     mObject;    // Weak ref to MediaPlayer Java object to call on<br />
};</pre>
</div>
<p>　　callback事件的传递主要是通过notify函数来完成的，下面看一下这个函数的具体实现过程：</p>
<div>
<pre class="prettyprint linenums">void JNIMediaPlayerListener::notify(int msg, int ext1, int ext2, const Parcel *obj)<br />
{<br />
    JNIEnv *env = AndroidRuntime::getJNIEnv();<br />
    if (obj &amp;&amp; obj-&gt;dataSize() &gt; ) {<br />
        jobject jParcel = createJavaParcelObject(env);<br />
        if (jParcel != NULL) {<br />
            Parcel* nativeParcel = parcelForJavaObject(env, jParcel);<br />
            nativeParcel-&gt;setData(obj-&gt;data(), obj-&gt;dataSize());<br />
            env-&gt;CallStaticVoidMethod(mClass, fields.post_event, mObject,<br />
                    msg, ext1, ext2, jParcel);<br />
            env-&gt;DeleteLocalRef(jParcel);<br />
        }<br />
    } else {<br />
        env-&gt;CallStaticVoidMethod(mClass, fields.post_event, mObject,<br />
                msg, ext1, ext2, NULL);<br />
    }<br />
    if (env-&gt;ExceptionCheck()) {<br />
        ALOGW("An exception occurred while notifying an event.");<br />
        LOGW_EX(env);<br />
        env-&gt;ExceptionClear();<br />
    }<br />
}</pre>
</div>
<ul><li><p>msg, ext1, ext2, obj 携带着事件相关信息及数据；</p></li>
<li><p>通过env-&gt;CallStaticVoidMethod()方法去回调MediaPlayer(java)的&nbsp;fields.post_event 方法，并将事件信息及数据传递过去；</p></li>
<li><p>fields.post_event对应于MediaPlayer的java 方法&nbsp;postEventFromNative；</p></li>
<li><p>fields.post_event是在MediaPlayer第一次加载时在android_media_MediaPlayer_native_init中初始化的；</p></li></ul>
<h2>三 &nbsp;小结</h2>
<p>　　这一篇介绍的内容很简单，主要是对java层的MediaPlayer， JNI层，及native层的MediaPlayer如何关联起来的有个基本的认识与了解。</p>
<p>　　简单两点概述：</p>
<ol><li>java层的MediaPlayer提供了java API供用户调用实现playback功能，但其功能的实现还会串接到JNI层，在JNI层会去实例化一个native MediaPlayer，这个native MediaPlayer会和MediaPlayerService进行交互实现真正的播放功能；</li>
<li>设置listener的目的就是通过回调的方式将来自native的事件进行上传，以便用户在java层做出处理，就这篇而言可以暂时这样理解流程: MediaPlayerService--&gt;native MediaPlayer--&gt;JNI-&gt;java MediaPlayer ;</li></ol>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390e61jq.html">VS 工程的 输出路径和工作路径的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnw0k2q.html">转载：log4j&period;properties log4j&period;xml 路径问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy31dj8.html">Odoo 8&period;0 实施开发指南 第一版 试读</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e11ndx9.html">JS点击复制</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd0jor8.html">python之递归</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y1jxnq.html">HDU 5927 Auxiliary Set 【DFS&plus;树】&lpar;2016CCPC东北地区大学生程序设计竞赛&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1n32v9.html">&lbrack;Javascript&rsqb; Promise</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv121e1q.html">C&num;操作Excel初探</a>
		</li>
						<li><a href="https://www.batexi.com/a/950gmde8.html">有关doctype&excl;&excl;&excl;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljd1mk9.html">基于docker 部署 canvas-lms</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r51lxeq.html">SQL DDL 数据定义语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/960rdzy9.html">C&num; DataTable 通过Linq分组</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy7k22q.html">Scheduler &amp;amp&semi; Task &amp;amp&semi; Worker &amp;amp&semi; Thread &amp;amp&semi; Request &amp;amp&semi; Session &amp;amp&semi; Connection of SQL Server</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv3e1k8.html">插头DP模板</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rzl649.html">Linux 向文件末尾追加命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ee0ex9.html">微信小程序&mdash;&mdash;template的使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/902y6emq.html">Android 开发工具类 28&lowbar;sendGETRequest</a>
		</li>
						<li><a href="https://www.batexi.com/a/93p3wl08.html">SpringMVC中properties文件读取</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kek0vq.html">pthread&lowbar;cond&lowbar;signal该放在什么地方？</a>
		</li>
						<li><a href="https://www.batexi.com/a/953l2508.html">web基础-----&amp;gt&semi;模板引擎Velocity的使用（二）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxdrj0e9.html">redhat换用centos源</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj0v3e9.html">listener failed&colon; zbx&lowbar;tcp&lowbar;listen&lpar;&rpar; fatal error&colon; unable to serve on any address &lbrack;&lbrack;-&rsqb;&colon;20050&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1ron49.html">怎么在Eclipse上运行静态网页</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvkoy38.html">redhat5 设置静态ip</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25n4vxq.html">【功能】返回数据类型、字节长度和在内部的存储位置&period;DUMP&lpar;w&lbrack;&comma;x&lbrack;&comma;y&lbrack;&comma;z&rsqb;&rsqb;&rsqb;&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r53vprq.html">VIM vim&sol;vi的文件内、跨文件复制粘贴操作、替换操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll2gj0q.html">hdu4812 逆元&plus;树分治</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wl0gwq.html">如何将自己的Image镜像Push到Docker Hub</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdr0zz9.html">接口隔离原则&lpar;Interface Segregation Principle&comma; ISP&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zypgj19.html">如何解决海量数据的Top K问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
